#------------------------------------------------------------------------------------------------
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted.
#------------------------------------------------------------------------------------------------
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
# WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#------------------------------------------------------------------------------------------------
# THIS PLUGIN IS ANOTHER FIGMENT OF MY IMAGENATION AND IS NOT BASED ON OR COMPLY WITH ANYTHING! 
#------------------------------------------------------------------------------------------------
# IT WAS CREATED AND ONLY TESTED IN A WINDOWS ENVIRONMENT AND MAY NOT FUNCTION ON A MAC.
#------------------------------------------------------------------------------------------------
#    Name:	Helix on Surface
#      By:	sdmitch
#   Usage:	Plugins>SDM Tools>Misc Tool>Helix on Surface
#		 Note:	
#			
#    Date:	
#------------------------------------------------------------------------------------------------
require 'Sketchup'
# ------------------  MENU SETUP ---------------------- #
unless $sdm_tools_menu
	$sdm_tools_menu = UI.menu("Plugins").add_submenu("SDM Tools")
	$sdm_Edge_tools = $sdm_tools_menu.add_submenu("Edge Tool")
	$sdm_Face_tools = $sdm_tools_menu.add_submenu("Face Tool")
	$sdm_CorG_tools = $sdm_tools_menu.add_submenu("CorG Tool")
	$sdm_Misc_tools = $sdm_tools_menu.add_submenu("Misc Tool")
end
unless file_loaded?(__FILE__)
	$sdm_Misc_tools.add_item("Helix on Surface") { SDM::Helix_On_Surface.main }
	file_loaded(__FILE__)
end
# ------------------------------------------------------ #
module SDM

	module Helix_On_Surface
	
		def self.main
		
			mod = Sketchup.active_model
			ent = mod.entities
			sel = mod.selection
			@anginc ||= 6.0; @pitch ||= 1.0
			specs = UI.inputbox(["Angle Inc:","       Pitch:"],[@anginc,@pitch],"Helix on Surface")
			if specs
				@anginc,@pitch = specs; hgtinc = @pitch/(360.0/@anginc)
				xaxis=Geom::Vector3d.new(1,0,0)
				yaxis=Geom::Vector3d.new(0,1,0)
				ctr=Geom::Point3d.new(0,0,0);
				pts=[];angle=0
				begin
					h=mod.raytest([ctr,xaxis])
					if h
						d=ctr.distance(h[0])
						xaxis.length=yaxis.length=d
						cosa = Math.cos(angle.degrees); sina = Math.sin(angle.degrees)
						vec = Geom::Vector3d.linear_combination(cosa,xaxis,sina,yaxis)
						pts.push ctr+vec;ctr.z += hgtinc
						angle += @anginc;angle %= 360
					else
						d=1e9
					end
				end while d < 1e6
				grp = ent.add_group; grp.entities.add_curve(pts)
			end
			
		end
		
	end
	
end